#include <SoftwareSerial.h>


#define rxPin 2 //sck
#define txPin 0 //mosi
#define sensorPin 3
int oldState =0; //This int is altered only if a new light status is reached.
char oldColor ='R';

SoftwareSerial mySerial = SoftwareSerial(rxPin, txPin);

void setup() {
  

  pinMode(sensorPin, INPUT); //phototransistor pin
  mySerial.begin(9600); //selected baudrate for my network
  

}

void loop() {
  int newState = 1; //This value corresponds to whatever the light level is at right now.
  char newColor = 'g';
 
  int  sensorValue = analogRead(sensorPin);
    if (sensorValue >=500){ //In this case, 500 is our threshold, it is what differentiates between 
      //"light enough so that no light is required and dark enough for light to be required"
      newState = 1;      //Essentially, "light" is 1 and "dark" is 0, with the threshold between them being 500. 
      //This value was found through trial and error and can be adjusted to preference.
    }
    else if (sensorValue < 500){
      newState = 0;
    }  
  if (mySerial.available()) {
    mySerial.write(sensorValue);
    delay (5000);
  }

  if (newState != oldState){ //If the new value is different from the old, i.e. we cross the threshold in either direction.
  
    sendCommand(); //Execute the sendCommand procedure
    oldState = newState; //then make the oldstate equal the newstate value.
  }
  
    if (mySerial.available()) {
            if (mySerial.read()=='r' || mySerial.read()=='g'||mySerial.read()=='b'||mySerial.read()=='w'){
              char newColor = mySerial.read();//The char newColor will only change if the received value is one of the values above.
            }
              if (newColor !=oldColor)//The BLE board is transmitting lower case characters. This board receives lower case and transmits upper case.
              {
                if (newColor=='r'){//The LED boards will only react to upper case, which means they will only react if this board is the sender.
                oldColor='R'; //The LED boards will therefore ignore messages from the BLE board.
                }
                if (newColor=='b'){
                oldColor='B';
                }
                if (newColor=='g'){
                oldColor='G';
                }
                if (newColor=='w'){
                oldColor='W';
                }
              }
            }
 
}

void sendCommand(){
int  sensorValue = analogRead(sensorPin);
if (sensorValue >=500) 
  {
    if (mySerial.available()){ //If the lightlevel is above or equal to 500 and the serial bus is available, send the "Off" command
    mySerial.print('o');//This is the off command
  }}
   
else 
{
  {if (mySerial.available()){ //If the lightlevel is not above or equal to 500 (i.e. it is dark), send the color command
   mySerial.print(oldColor);} //this transmits the char value designated as oldColor. 
}
}
  }


